<template>
    <div class="edit-popup">
        <popup ref="popupRef" :title="popupTitle" :async="true" width="550px" @confirm="handleSubmit" @close="handleClose">
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="项目名称" prop="project_id">
                    <el-input v-model="formData.project_name" @click="showDialog = true" clearable placeholder="点击选择项目" />
                </el-form-item>
                <el-form-item label="技术人员" prop="technician_ids">
                    <el-input v-model="formData.technician_ids" clearable placeholder="请输入技术人员" />
                </el-form-item>
                <el-form-item label="商务人员" prop="business_people_ids">
                    <el-input v-model="formData.business_people_ids" clearable placeholder="请输入商务人员" />
                </el-form-item>
                <el-form-item label="跨部门人员" prop="cross_departmental_personnel_ids">
                    <el-input v-model="formData.cross_departmental_personnel_ids" clearable placeholder="请输入跨部门人员" />
                </el-form-item>
                <el-dialog v-model="showDialog" title="选择客户" width="70%">
                    <projectTable @customEvent="customEvent"></projectTable>

                </el-dialog>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="projectPreSalesMembersEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import projectTable from "@/components/tablieDialog/project.vue"
import { apiProjectPreSalesMembersAdd, apiProjectPreSalesMembersEdit, apiProjectPreSalesMembersDetail } from '@/api/project_pre_sales_members'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')
// dialog
const showDialog = ref(false)
const customEvent = (e: any) => {
    formData.project_id = e.id;
    formData.project_name = e.name;
    showDialog.value = false;
};

// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑售前项目成员' : '新增售前项目成员'
})

// 表单数据
const formData = reactive({
    id: '',
    project_id: '',
    project_name: "",
    technician_ids: '',
    business_people_ids: '',
    cross_departmental_personnel_ids: '',
})


// 表单验证
const formRules = reactive<any>({

})


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }


}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiProjectPreSalesMembersDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData, }
    mode.value == 'edit'
        ? await apiProjectPreSalesMembersEdit(data)
        : await apiProjectPreSalesMembersAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
